archetype/archetype/views/calculator.py
import binascii
import http.client
import json
import os
import random
import typing

import flask
import werkzeug.exceptions

from .. import database


calculator_blueprint = flask.Blueprint(
	"calculator",
	__name__
)

def path_exists(path: str) -> bool:
	return os.path.exists(
		os.path.abspath(
			os.path.dirname(__file__)
		)
		+ "/"
		+ path
	)


@calculator_blueprint.route("/pypl")
def view_archetypes() -> typing.Tuple[flask.Response, int]:
	return flask.render_template(
		"archetypes.html"
	), http.client.OK


def get_closest_candidates(
	primary_slug: str,
	secondary_slug: str,
	district: typing.Union[str, None] = None,
	excluded_slugs: typing.List[str] = []
) -> typing.Dict:
	closest_candidates = []

	closest_primary_candidates = []
	closest_secondary_candidates = []

	for candidate_slug, candidate in flask.current_app.config["PEOPLE"].items():
		if (
			(
				district is not None
				and district != candidate["district"]
			) or candidate_slug in excluded_slugs
		):
			continue

		candidate["slug"] = candidate_slug
		
		if candidate["primary_archetype"] == primary_slug:
			if candidate["secondary_archetype"] == secondary_slug:
				closest_primary_candidates.insert(0, candidate)
			else:
				closest_primary_candidates.append(candidate)
		elif (
			candidate["primary_archetype"] == secondary_slug
			or candidate["secondary_archetype"] == secondary_slug
			or candidate["secondary_archetype"] == primary_slug
		):
			closest_secondary_candidates.append(candidate)

	closest_candidates = (
		closest_primary_candidates
		+ closest_secondary_candidates
	)[:flask.current_app.config["TOP_CANDIDATE_MAX_COUNT"]]

	leaders = []

	for position, candidate in enumerate(closest_candidates):
		if candidate.get("is_leader", False):
			leaders.append(candidate)
			closest_candidates.pop(position)

	return leaders + closest_candidates


@calculator_blueprint.route(
	"/pypl/<string:primary_slug>/<string:secondary_slug>"
)
def view_archetype(
	primary_slug: str,
	secondary_slug: str
) -> typing.Tuple[flask.Response, int]:
	district = flask.request.cookies.get("district")
	
	if (
		primary_slug not in flask.current_app.config["ARCHETYPES"]
		or secondary_slug not in flask.current_app.config["ARCHETYPES"]
	):
		raise werkzeug.exceptions.NotFound

	closest_district_candidates = (
		[]
		if district is None
		else get_closest_candidates(
			primary_slug,
			secondary_slug,
			district
		)
	)

	closest_candidates = get_closest_candidates(
		primary_slug,
		secondary_slug,
		None,
		excluded_slugs=[
			candidate["slug"]
			for candidate
			in closest_district_candidates
		]
	)

	response = flask.make_response(
		flask.render_template(
			"result_archetype.html",
			primary_slug=primary_slug,
			secondary_slug=secondary_slug,
			primary_archetype=(
				flask.current_app.config
				["ARCHETYPES"]
				[primary_slug]
			),
			secondary_archetype=(
				flask.current_app.config
				["ARCHETYPES"]
				[secondary_slug]
			),
			closest_district_candidates=closest_district_candidates,
			closest_candidates=closest_candidates,
			path_exists=path_exists,
			gender=flask.request.cookies.get("gender", "neutral"),
			district=district
		)
	)

	response.set_cookie(
		"primary_archetype",
		primary_slug
	)
	response.set_cookie(
		"secondary_archetype",
		secondary_slug
	)

	return response, http.client.OK


@calculator_blueprint.route("/vysledky", methods=["GET"])
def view_results() -> typing.Tuple[flask.Response, int]:
	primary_archetype = flask.request.cookies.get("primary_archetype")
	secondary_archetype = flask.request.cookies.get("secondary_archetype")

	if (
		primary_archetype not in flask.current_app.config["ARCHETYPES"]
		or secondary_archetype not in flask.current_app.config["ARCHETYPES"]
	):
		raise werkzeug.exceptions.NotFound

	return view_archetype(
		primary_slug=primary_archetype,
		secondary_slug=secondary_archetype
	)


@calculator_blueprint.route("/", methods=["GET", "POST"])
def index() -> typing.Tuple[flask.Response, int]:
	gender = flask.request.cookies.get("gender", "neutral")

	if flask.request.method == "GET":
		questions = list(
			flask.current_app.config["QUESTIONS"].items()
		)

		random.shuffle(questions)

		questions = dict(questions)

		return flask.render_template(
			"index.html",
			gender=gender,
			questions=questions
		), http.client.OK
	else:
		answers = flask.request.form.get("answers")
		district = flask.request.cookies.get("district")

		if answers is None:
			raise werkzeug.exceptions.BadRequest

		try:
			decoded_answers = json.loads(flask.request.form["answers"])
		except (binascii.Error, ValueError):
			raise werkzeug.exceptions.BadRequest

		if not isinstance(decoded_answers, dict):
			raise werkzeug.exceptions.BadRequest

		pirate_archetypes = {}
		anti_pirate_archetypes = {}
		skipped_response_count = 0


		for question_slug, answer in decoded_answers.items():
			if (
				question_slug not in flask.current_app.config["QUESTIONS"]
				or answer not in ("pos-important", "pos", "neg", "neg-important", "skipped")
			):
				raise werkzeug.exceptions.BadRequest

			question = flask.current_app.config["QUESTIONS"][question_slug]

			if answer in ("pos-important", "pos"):
				point_multiplier = (
					1 if answer == "pos"
					else 2
				)

				if question["is_pirate"]:
					for archetype_slug, point_amount in question["points"].items():
						if archetype_slug not in pirate_archetypes:
							pirate_archetypes[archetype_slug] = 0

						pirate_archetypes[archetype_slug] += point_amount * point_multiplier
				else:
					for archetype_slug, point_amount in question["points"].items():
						if archetype_slug not in anti_pirate_archetypes:
							anti_pirate_archetypes[archetype_slug] = 0

						anti_pirate_archetypes[archetype_slug] += point_amount * point_multiplier
			
			# Simpler to understand comparison, though slightly less efficient.
			# Could use `!= "skipped"` instead
			elif answer in ("neg-important", "neg"):
				point_multiplier = (
					1 if answer == "neg"
					else 2
				)

				if "negative_points" in question:
					for archetype_slug, point_amount in question["negative_points"].items():
						if archetype_slug not in pirate_archetypes:
							pirate_archetypes[archetype_slug] = 0

						pirate_archetypes[archetype_slug] += point_amount * point_multiplier
			else:
				skipped_response_count += 1

		if len(anti_pirate_archetypes) != 0:
			# https://geekflare.com/python-dictionary-sorting/
			# Thanks to Geekflare!
			anti_pirate_archetypes = dict(
				sorted(
					anti_pirate_archetypes.items(),
					key=lambda item:item[1],
					reverse=True
				)
			)

			slug = list(anti_pirate_archetypes.keys())[0]

			if (
				anti_pirate_archetypes[slug]
				>= (
					flask.current_app.config["ANTI_PIRATE_MAX_POTENTIAL_POINTS"]
					* flask.current_app.config["ANTI_PIRATE_TRESHOLD"]
				)
			):
				return flask.render_template(
					"anti_pirate_archetype_result.html",
					archetype=(
						flask.current_app.config
						["ARCHETYPES"]
						[slug]
					),
					archetype_slug=slug,
					gender=gender
				), http.client.OK


		# https://geekflare.com/python-dictionary-sorting/
		# Thanks to Geekflare!
		pirate_archetypes = dict(
			sorted(
				pirate_archetypes.items(),
				key=lambda item:item[1],
				reverse=True
			)
		)
		
		positive_response_share = (
			pirate_archetypes[list(pirate_archetypes)[0]]
			/ flask.current_app.config["TOTAL_MAX_POTENTIAL_POINTS"]
		)

		if positive_response_share < (
			1 - flask.current_app.config["WINNING_ARCHETYPE_TRESHOLD"]
		):
			return flask.render_template(
				"result_no_archetype.html",
				gender=gender,
				too_many_skipped=False  # FIXME: Workaround for now
			), http.client.OK

		slugs = list(pirate_archetypes.keys())
		primary_slug = slugs[0]
		secondary_slug = slugs[1]

		response = flask.make_response(
			flask.redirect(
				flask.url_for("calculator.view_results")
			)
		)

		response.set_cookie(
			"primary_archetype",
			primary_slug
		)

		response.set_cookie(
			"secondary_archetype",
			secondary_slug
		)

		return response

archetype/archetype/templates/anti_pirate_archetype_result.html
{% extends 'base.html' %}

{% block head %}
	<link
		rel="stylesheet"
		type="text/css"
		href="{{ url_for('static', filename='css/anti_pirate_archetype_result.css') }}"
	>
	<link
		rel="stylesheet"
		type="text/css"
		href="{{ url_for('static', filename='fonts/open-sans/style.css') }}"
	>
	<link
		rel="stylesheet"
		type="text/css"
		href="{{ url_for('static', filename='fonts/bebas-neue/style.css') }}"
	>
{% endblock %}

{% block current_page %}{{ archetype["names"][gender] }}{% endblock %}

{% block description %}{{ archetype["descriptions"][gender] }}{% endblock %}

{% block content %}
	<main>
		<div class="container">
			<div class="image-area">
				<img
					id="image"
					width="300"
					height="300"
					src="static/images/types/{{ archetype_slug }}.svg"
					alt="Ikona {{ archetype["names"][gender] }}"
				>
			</div>
			<div class="description-area">
				<h1>Bohužel, jsi {{ archetype["names"][gender] }}.</h1>
				
				<p>
					{{ archetype["descriptions"][gender]|safe }}
				</p>
			</div>
		</div>
		
		<a
			id="retry-test"
			href="/"
		>Zkusit test znovu&nbsp;&nbsp;→</a>
	</main>
{% endblock %}

archetype/archetype/templates/archetypes.html
{% extends 'base.html' %}


{% block content %}
	<header>
		<h1>Archetypy</h1>
	</header>
	
	<main>
		<ul>
			{% for primary_archetype_slug, primary_archetype in config["ARCHETYPES"].items() %}
				<li>
					<h2>{{ primary_archetype["names"]["neutral"] }}</h2>
					
					<ul>
						{%
							for secondary_archetype_slug, secondary_archetype
							in config["ARCHETYPES"].items()
							if secondary_archetype_slug != primary_archetype_slug
						%}
							<li>
								<a
									href="{{
										url_for(
											'calculator.view_archetype',
											primary_slug=primary_archetype_slug,
											secondary_slug=secondary_archetype_slug
										)
									}}"
								>{{ secondary_archetype["referers"]["neutral"] }}</a>
							</li>
						{% endfor %}
					</ul>
				</li>
			{% endfor %}
		</ul>
	</main>
{% endblock %}

archetype/archetype/templates/base.html
<!DOCTYPE html>
<html lang="cs">
	<head>
		<meta charset="utf-8">
		<meta name="viewport" content="width=device-width, initial-scale=1">
		
		<link
			rel="stylesheet"
			type="text/css"
			href="{{ url_for('static', filename='css/base.css') }}"
		>
		<link
			rel="icon"
			type="image/png"
			href="{{ url_for('static', filename='images/icon.png') }}"
		>
		<script
			src="{{ url_for('static', filename='js/jquery.js') }}"
			type="text/javascript"
		></script>
		
		<meta name="author" content="Piráti">
		<meta
			name="description"
			content="{% block description %}{% endblock %}"
		>
		<meta
			name="copyright"
			content="Všechna práva vyhlazena."
		>
		
		<meta
			property="og:title"
			content="{% block current_page %}{% endblock %}"
		>
		<meta
			property="og:description"
			content="{{ self.description() }}"
		>
		
		{% block head %}{% endblock %}
		
		<title>{{ self.current_page() }}</title>
	</head>
	<body>
		{% block content %}{% endblock %}
	</body>
</html>

archetype/archetype/templates/result_archetype.html
{% extends 'base.html' %}

{% block head %}
	<link
		rel="stylesheet"
		type="text/css"
		href="{{ url_for('static', filename='css/select2.min.css') }}"
	>
	
	<link
		rel="stylesheet"
		type="text/css"
		href="{{ url_for('static', filename='css/result_archetype.css') }}"
	>
	<link
		rel="stylesheet"
		type="text/css"
		href="{{ url_for('static', filename='fonts/open-sans/style.css') }}"
	>
	<link
		rel="stylesheet"
		type="text/css"
		href="{{ url_for('static', filename='fonts/bebas-neue/style.css') }}"
	>
	
	<script
		type="text/javascript"
		src="{{ url_for('static', filename='js/jquery.js') }}"
	></script>
	<script
		type="text/javascript"
		src="{{ url_for('static', filename='js/select2.min.js') }}"
	></script>
	<script
		type="text/javascript"
		src="{{ url_for('static', filename='js/js.cookie.min.js') }}"
	></script>
	
	<script
		type="text/javascript"
		src="{{ url_for('static', filename='js/result_archetype.js') }}"
	></script>
{% endblock %}

{% block current_page %}
	Jsi
	{{ secondary_archetype["referers"][gender] }}
	{{ primary_archetype["names"][gender] }}
	!
{% endblock %}

{% block description %}{{ primary_archetype["descriptions"][gender] }}{% endblock %}

{% block content %}
	<main>
		<div
			id="initial-result"
			style="background-color:{{ primary_archetype["result-background"] }}"
		>
			<div id="result-header-container">
				<div class="image-area">
					<img
						id="image"
						width="300"
						height="300"
						src="{{ url_for('static', filename='images/types/' + primary_slug + '.svg') }}"
						alt="Ikona {{ primary_archetype["names"][gender] }}"
					>
				</div>
				<div class="description-area">
					<div id="heading-container">
						<div id="heading">
							<h1>Jsi {{ secondary_archetype["referers"][gender] }} {{ primary_archetype["names"][gender].lower() }}!</h1>
							<h2>Přesně v souladu s Piráty.</h2>
						</div>
					</div>
					
					<h2>
						Což je kombinace dvou archetypů - první je {{ primary_archetype["names"][gender] }}.
					</h2>
					
					<p>
						{{ primary_archetype["descriptions"][gender]|safe }}
					</p>
					
					<h2>A druhý je {{ secondary_archetype["names"][gender] }}.</h2>
					
					<p>
						{{ secondary_archetype["descriptions"][gender]|safe }}
					</p>
				</div>
			</div>
			
			<a
				href="#blizsi-info"
			>
				<img
					id="down-arrow"
					src="{{ url_for('static', filename='images/down-arrow.svg') }}"
					width="40"
				>
			</a>
		</div>
		
		<div id="blizsi-info">
			<div id="blizsi-info-top">
				<h2 id="blizsi-info-header">A tady jsou Piráti, kteří ti nejvíc sednou.</h2>
				
				<select id="district">
					<option
						value="none"
						{% if district is none %}selected{% endif %}
					>Podle oblasti</option>
					
					{% for region in config["REGIONS"].values() %}
						<optgroup label="{{ region['name'] }}">
							{% for district_slug in region["districts"] %}
								<option
									value="{{ district_slug }}"
									{% if district_slug == district %}selected{% endif %}
								>{{ config["DISTRICTS"][district_slug]["name"] }}</option>
							{% endfor %}
						</optgroup>
					 {% endfor %}
				</select>
			</div>
			
			{% if closest_candidates|length == 0 and closest_district_candidates|length == 0 %}
				<p>
					Ať se to stalo jakkoliv, bohužel jsme žádné nenašli.<br>
					Možná od nich ještě nemáme odpovědi.
				</p>
			{% else %}
				<ul id="candidates">
					{% macro render_candidates(candidates) -%}
						{%
							for candidate
							in candidates
						%}
							<li class="candidate">
								<img
									class="candidate-avatar"
									alt="Obrázek kandidáta {{ candidate['name'] }}"
									src="{% if path_exists('../static/images/people/' + candidate['slug'] + '.webp') %}
										{{ url_for('static', filename='images/people/' + candidate['slug'] + '.webp') }}
									{% else %}
										https://a.pirati.cz/common/img/people/unknown-pirate.svg
									{% endif %}"
								>
								
								<div class="candidate-info">
									<h3 class="candidate-name">{{ candidate['name'] }}</h3>
									
									<div class="candidate-bottom-info">
										<h4 class="candidate-archetype">
											{% set has_secondary = candidate["secondary_archetype"] is not none %}
											
											{% if has_secondary %}
												{{
													config
													["ARCHETYPES"]
													[candidate["secondary_archetype"]]
													["referers"]
													[candidate.get("gender", "neutral")]
												}}
											{% endif %}
											
											{% set
												primary_desc = (
													config
													["ARCHETYPES"]
													[candidate["primary_archetype"]]
													["names"]
													[candidate.get("gender", "neutral")]
												)
											%}
											
											{% if has_secondary %}
												{{ primary_desc.lower() }}
											{% else %}
												{{ primary_desc }}
											{% endif %}
										</h4>
										
										<h4 class="candidate-location">
											{{
												config
												["DISTRICTS"]
												[candidate["district"]]
												["name"]
											}}
											
											-
											
											{{
												config
												["REGIONS"]
												[
													config
													["DISTRICTS"]
													[candidate["district"]]
													["region"]
												]
												["name"]
											}}
										</h4>
										
										{% if candidate["description"] != "" %}
											<p class="candidate-description">
												{{ candidate["description"] }}
											</p>
										{% endif %}
									</div>
								</div>
							</li>
						{% endfor %}
					{% endmacro -%}
					
					{% if closest_district_candidates|length != 0 %}
						<h3>Z tvé oblasti</h3>
						
						{{ render_candidates(closest_district_candidates) }}
						
						<h3>Z celého Česka</h3>
					{% else %}
						{% if district is not none %}
							<p>
								<b>Bohužel, z tvojí oblasti jsme nikoho nenašli.</b> Tady máš aspoň ostatní Piráty a Pirátky.
							</p>
						{% endif %}
					{% endif %}
					
					{{ render_candidates(closest_candidates) }}
				</ul>
			{% endif %}
			
			<div id="bottom-buttons">
				<a
					href="{{ url_for('calculator.index') }}"
					id="restart"
				><img
					alt="Restartovat"
					src="{{ url_for('static', filename='images/retry.svg') }}"
					width="30"
				></a>
			</div>
		</div>
	</main>
{% endblock %}

archetype/archetype/templates/result_no_archetype.html
{% extends 'base.html' %}

{% block head %}
	<link
		rel="stylesheet"
		type="text/css"
		href="{{ url_for('static', filename='css/result_no_archetype.css') }}"
	>
	<link
		rel="stylesheet"
		type="text/css"
		href="{{ url_for('static', filename='fonts/open-sans/style.css') }}"
	>
	<link
		rel="stylesheet"
		type="text/css"
		href="{{ url_for('static', filename='fonts/bebas-neue/style.css') }}"
	>
{% endblock %}

{% block current_page %}Bohužel!{% endblock %}

{% block description %}Nemohli jsme pro tebe najít archetyp.{% endblock %}

{% block content %}
	<main>
		<img
			src="{{ url_for("static", filename="images/no-archetype.svg") }}"
			alt="Bez archetypu"
			width="250"
			height="250"
		>
		
		<div id="result-heading">
			<h1>Bohužel, nenašli jsme pro tebe typ.</h1>
			
			<p>
				{% if too_many_skipped %}
					{% if gender == "male" %}
						Přeskočil
					{% elif gender == "female" %}
						Přeskočila
					{% else %}
						Přeskočil(a)
					{% endif %}
					
					jsi moc otázek. Pokud chceš, můžeš to zkusit znovu. :)
				{% else %}
					Ale na některých věcech se snad stejně shodneme. :)
				{% endif %}
			</p>
		</div>
		
		<a
			id="retry-test"
			href="/"
		>Zkusit test znovu&nbsp;&nbsp;→</a>
	</main>
{% endblock %}